'''
Projekt Partikelsimulation aus dem Wintersemester 2020/21 im Rahmen des Mathesis Projektlabors von
Paulina Marie Fritze,
Berhan Rêzan Isik,
Moritz Merkel und
Amelie Schäfer
'''
import random as rd
import vpython as vp
import time
#Konstanten
height=width=length=3000
n=35

partikel=[] #{x,y,(z),dx,dy,(dz),m}
for i in range(n):
    partikel.append({'x': rd.randint(-width,width),'y': rd.randint(-height,height),'z': rd.randint(-length,length),'dx': 6*rd.random()-3,'dy': 6*rd.random()-3,'dz': 6*rd.random()-3,'m': rd.random()*1000})

kugeln=[vp.sphere(pos=vp.vector(partikel[i]['x'],partikel[i]['y'],partikel[i]['z']),radius=20) for i in range(n)]
time.sleep(5)

def norm(x,y,z):
    return (x**2+y**2+z**2)**0.5
    #alternative Metrik
    #return abs(x)+abs(y)+abs(z)
    #supremumsnorm
    #return max(abs(x),abs(y),abs(z)

    #F=G*m1*m2/(r^2)
def Gravitation(p1, p2, G=70):
#punkt + einheitsrichtungsvektor * beschleunigung
    dx,dy,dz=(p2['x']-p1['x']),(p2['y']-p1['y']),(p2['z']-p1['z'])
    d=norm(dx,dy,dz)
    if d==0:
        return (0,0,0)
    F=G*p1['m']*p2['m']/d**2
    a=F/p1['m']
    dx,dy,dz=a*dx/d,a*dy/d,a*dz/d
    return (dx,dy,dz)
def Reibung(p1,c=-0.001):
    return (c*p1['dx']/p1['m'],c*p1['dy']/p1['m'],c*p1['dz']/p1['m'])

#main loop
while True:
    vp.rate(60)
    i=0
    j=0
    gesamtsplitteranzahl=0
    while i < len(partikel)-gesamtsplitteranzahl:
        j=i+1
        while j < len(partikel)-gesamtsplitteranzahl:
            d=norm(partikel[j]['x']-partikel[i]['x'],partikel[j]['y']-partikel[i]['y'],partikel[j]['z']-partikel[i]['z'])
            if d<(kugeln[i].radius+kugeln[j].radius)/2:
                differenz=norm(partikel[i]['dx']-partikel[j]['dx'],partikel[i]['dy']-partikel[j]['dy'],partikel[i]['dz']-partikel[j]['dz'])
                treshold=80
                if differenz<treshold or len(partikel)>150:
                    #Fusion
                    partikel[i]['dx']=(partikel[i]['m']*partikel[i]['dx']+partikel[j]['m']*partikel[j]['dx'])/(partikel[i]['m']+partikel[j]['m'])
                    partikel[i]['dy']=(partikel[i]['m']*partikel[i]['dy']+partikel[j]['m']*partikel[j]['dy'])/(partikel[i]['m']+partikel[j]['m'])
                    partikel[i]['dz']=(partikel[i]['m']*partikel[i]['dz']+partikel[j]['m']*partikel[j]['dz'])/(partikel[i]['m']+partikel[j]['m'])
                    partikel[i]['m']+=partikel[j]['m']
                    partikel.pop(j)
                    kugeln[j].visible=False
                    kugeln.pop(j)
                else:
                    #Explosion
                    splitteranzahl=4*2#gerade zahl
                    masse=(partikel[i]['m']+partikel[j]['m'])/splitteranzahl
                    #splitteranzahl*m*v^2=m1*v1^2+m2*v2^2=c
                    v=((partikel[i]['m']*norm(partikel[i]['dx'],partikel[i]['dy'],partikel[i]['dz'])**2+partikel[j]['m']*norm(partikel[j]['dx'],partikel[j]['dy'],partikel[j]['dz'])**2)/(splitteranzahl*masse))**0.5
                    splitterpartikel=[{'x':0,'y':0,'z':0,'dx':2*rd.random()-1,'dy':2*rd.random()-1,'dz':2*rd.random()-1,'m':0} for k in range(int(splitteranzahl/2))]
                    splitterpartikel=[{'x':partikel[i]['x'],'y':partikel[i]['y'],'z':partikel[i]['z'],'dx':splitterpartikel[k]['dx']*v/norm(splitterpartikel[k]['dx'],splitterpartikel[k]['dy'],splitterpartikel[k]['dz']),                                                                                                                                                                                                                                                                         'dy':2*splitterpartikel[k]['dy']*v/norm(splitterpartikel[k]['dx'],splitterpartikel[k]['dy'],splitterpartikel[k]['dz']),'dz':splitterpartikel[k]['dx']*v/norm(splitterpartikel[k]['dz'],splitterpartikel[k]['dy'],splitterpartikel[k]['dz']),'m':masse} for k in range(int(splitteranzahl/2))]
                    splitterpartikel+=[{'x':partikel[i]['x'],'y':partikel[i]['y'],'z':partikel[i]['z'],'dx':-splitterpartikel[k]['dx'],'dy':-splitterpartikel[k]['dy'],'dz':-splitterpartikel[k]['dx'],'m':masse} for k in range(int(splitteranzahl/2))]
                    for k in range(splitteranzahl):
                        splitterpartikel[k]['dx']+=(partikel[i]['m']*partikel[i]['dx']+partikel[j]['m']*partikel[j]['dx'])/(partikel[i]['m']+partikel[j]['m'])
                        splitterpartikel[k]['dy']+=(partikel[i]['m']*partikel[i]['dy']+partikel[j]['m']*partikel[j]['dy'])/(partikel[i]['m']+partikel[j]['m'])
                        splitterpartikel[k]['dz']+=(partikel[i]['m']*partikel[i]['dz']+partikel[j]['m']*partikel[j]['dz'])/(partikel[i]['m']+partikel[j]['m'])
                    partikel.pop(j)
                    kugeln[j].visible=False
                    kugeln.pop(j)
                    partikel.pop(i)
                    kugeln[i].visible=False
                    kugeln.pop(i)

                    gesamtsplitteranzahl+=splitteranzahl
                    partikel+=splitterpartikel
                    kugeln+=[vp.sphere(pos=vp.vector(splitterpartikel[k]['x'],splitterpartikel[k]['y'],splitterpartikel[k]['z']),radius=20) for k in range(splitteranzahl)]
            else:
                j+=1
        i+=1

    #Geschwindigkeit aktualisieren
    #Gravitation
    for i in range(len(partikel)):#Hauptpartikel
        for j in range(len(partikel)):
            if i==j:
                continue
            d=Gravitation(partikel[i],partikel[j])#(dx,dy)
            partikel[i]['dx']+=d[0]
            partikel[i]['dy']+=d[1]
            partikel[i]['dz']+=d[2]

    for i in range(len(partikel)):
        d=Reibung(partikel[i])
        partikel[i]['dx']+=d[0]
        partikel[i]['dy']+=d[1]
        partikel[i]['dz']+=d[2]
    #Position aktualisieren

    for i in range(len(partikel)):
        partikel[i]['x']+=partikel[i]['dx']
        partikel[i]['y']+=partikel[i]['dy']
        partikel[i]['z']+=partikel[i]['dz']
    #vpython
    for i in range(len(partikel)):
        kugeln[i].radius=15*partikel[i]['m']**(1/3)
        kugeln[i].pos=vp.vector(partikel[i]['x'],partikel[i]['y'],partikel[i]['z'])
